import MySQLdb
import time
import smtplib
#import socket

from time import gmtime, strftime, localtime
#disable Mysql Warning
from warnings import filterwarnings
filterwarnings('ignore', category = MySQLdb.Warning)

#Enable Mysql Warning
#from warnings import resetwarnings
#resetWarnings()


global db
#global emailMsg

#emailMsg = ""

from sqlalchemy import create_engine, text

from setting import *
global setting
setting = mysetting()

print setting.dbtype
print setting.dbserver
print setting.dbport
print setting.dbuserid
print setting.dbpassword
print setting.dbschema
print setting.stnno

#gmail_user = 'izzatzul4@gmail.com'  
#gmail_password = 'izzat'

#gmail_receiver = 'izzatzul7@gmail.com'

from email.MIMEText import MIMEText
from email.MIMEBase import MIMEBase
from email import encoders
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText

import email.Utils

from datetime import datetime, timedelta

from dateutil.relativedelta import *

# New ######

fromaddr = "iDS900 Smock Tester <smockesd@sanmina.com>"
#toaddr = "mueducom@yahoo.com, izzatzul4@gmail.com, limwaikai2@yahoo.com"
toaddr = ""
HOST = "mailhub.sanmina.com"
############# end

global taskname
global procname
global dinterval
global dintervaltype
global nextrun

taskname = "Test1"
procname = "sudo date"
dinterval = 999
dintervaltype = "MILLISECOND"
nextrun = datetime.strptime("1900-01-01 00:00:00", "%Y-%m-%d %H:%M:%S")


global VERSION
VERSION = 'Ver. 1.00 - 20200120'


def getStartTime(strlastrun, intervaltype, dinterval):
    while strlastrun >= email_endtime:
        if intervaltype == 'DAY':
            strlastrun = strlastrun - relativedelta(days=dinterval)
        elif intervaltype == 'HOUR':
            strlastrun = strlastrun - relativedelta(hours=dinterval)
        elif intervaltype == 'MINUTE':
            strlastrun = strlastrun - relativedelta(minutes=dinterval)
        elif intervaltype == 'MONTH':
            strlastrun = strlastrun - relativedelta(months=dinterval)

    return strlastrun


email_endtime = datetime.now()
email_starttime = getStartTime(email_endtime, 'MONTH', 3)

print(email_starttime.strftime('%Y-%m-%d %H:%M'))

#socket.getaddrinfo('localhost', 25)

def save_EmailWeblog(emailSubject, Recipients):
    global db

    try:
        action_result = 'Email Subject: ' + str(emailSubject) + "<br>" + \
                        "Recipients: " + str(Recipients)
        strSQL = "INSERT INTO weblog(timedate, action_taken, upd_by, action_sql) " + \
                 "VALUES(GETDATE(), 'EMAIL', 'SYSTEM', '" + action_result + "') "

        #print('save_EmailWeblog SQL: ' + str(strSQL))
        sql = text(strSQL)
        db.execute(sql)
    except Exception as e:
        print('save_EmailWeblog: ' + str(e))
        

def emailSent(emailaddress, emailMsg):
    print('')
    print('emailSent start')
##    print('##########')
##    print(emailMsg)
##    print('##########')
##    print('')
    
    global db
    
    global email_starttime
    global email_endtime
    try:

        email_starttime = getStartTime(email_endtime, dintervaltype, dinterval)

        msg = MIMEMultipart()
        msg["Message-id"] = email.Utils.make_msgid()
        msg['From'] = fromaddr
        msg['To'] = emailaddress #toaddr
        msg['Subject'] = "ESD Smock Test Due Soon Report " + \
                         email_starttime.strftime('%Y-%m-%d %H:%M') + " - " + \
                         email_endtime.strftime('%Y-%m-%d %H:%M')


        text = "LastUpdate: " + strftime("%Y-%m-%d %H:%M:%S", localtime())

        
        tHtml = """
        <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
          <title>NoTest Smock Report</title>
          <style type="text/css" media="screen">
          table {
                width:100%;
            }
            table, th, td {
                border: 1px solid black;
                border-collapse: collapse;
            }
            th, td {
                padding: 5px;
                text-align: left;
            }
            table tr {
                background-color: #E6E6FA;
                color: RED;
                empty-cells:hide;
            }
            table th {
                background-color: #F0E68C;
                color: Black;
                empty-cells:hide;
            }
          </style>
        </head>
        <body>
        """
        tHtml = tHtml + emailMsg + "</body>"
        part1 = MIMEText(tHtml, 'html')
        part2 = MIMEText(text, 'html')
        msg.attach(part1)
        #msg.attach(part2)

        
        server2 = smtplib.SMTP(HOST)

        if emailaddress != "":
            print('emailaddress:' + emailaddress + "#")
            #print(msg.as_string())
            server2.sendmail(fromaddr, emailaddress, msg.as_string())

            save_EmailWeblog(str(msg['Subject']), emailaddress)

        server2.quit()

        print(emailaddress + ' - Email sent!')
    except Exception as e:  
        print ("Something went wrong..." + str(e))
    finally:
        print('emailSent done')




def dbConnect():
    global db
    try:
        if setting.dbtype.upper() == 'MSSQL':
            dbdriver = 'mssql+pymssql'
        else:
            dbdriver = 'mysql'

        conn_str = dbdriver + '://' + \
                   str(setting.dbuserid) + \
                   ':' + str(setting.dbpassword) + \
                   '@' + str(setting.dbserver) + ':' + str(int(setting.dbport)) + \
                   '/' + str(setting.dbschema)
        timeout = {}
        if setting.dbtype == 'MSSQL':
            timeout['timeout'] = 3
            timeout['login_timeout'] = 5
        else:
            timeout['connect_timeout'] = 3
        
        db = create_engine(conn_str, echo=False, connect_args=timeout)
        
    except:
        db = None
        print("Error: Fail connect to DB")


def chkNoTestONLY():

    global db

    try:
        print('chkNoTestONLY start')

        if setting.dbtype.upper() == 'MSSQL':

            myenddate = "GETDATE() "
            
            if dintervaltype.upper() == "DAY":
                mystartdate = "DATEADD(DAY, -" + str(dinterval) + ", GETDATE())"
            elif dintervaltype.upper() == "HOUR":
                mystartdate = "DATEADD(HOUR, -" + str(dinterval) + ", GETDATE())"
            elif dintervaltype.upper() == "MINUTE":
                mystartdate = "DATEADD(MINUTE, -" + str(dinterval) + ", GETDATE())"
            elif dintervaltype.upper() == "MONTH":
                mystartdate = "DATEADD(MONTH, -" + str(dinterval) + ", GETDATE())"
            else:
                mystartdate = "GETDATE() "
        else:

            myenddate = "SYSDATE() "
            
            if dintervaltype.upper() == "DAY":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " DAY) "
            elif dintervaltype.upper() == "HOUR":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " HOUR) "
            elif dintervaltype.upper() == "MINUTE":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " MINUTE) "
            elif dintervaltype.upper() == "MONTH":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " MONTH) "
            else:
                mystartdate = "SYSDATE() "
            
        strSQL = "SELECT timedate, cardno, tbl1.emp_id, emp_name, dept_id, sm, " + \
                 "result, smval, smlo, smhi, sup_id, supname, supemail FROM ( " + \
                 " SELECT '' AS timedate, card_no AS cardno, emp_id, " + \
                 " emp_name, sup_id, department AS dept_id, '' AS sm, " + \
                 " 'Due soon' AS result, '' AS smval, '' AS smlo, '' AS smhi " + \
                 " FROM employee " + \
                 " WHERE emp_id NOT IN ( " + \
                 "     SELECT emp_id from ( " + \
                 "         SELECT timedate, cardno, emp_id, emp_name, sup_id, " + \
                 "         dept_id, sm, result, smval, smlo, smhi " + \
                 "         FROM smockresult WHERE 1=1 and timedate >= " + mystartdate + \
                 "         and timedate <= " + myenddate + " " \
                 "     )tblEmp " + \
                 " ) AND emp_id <> 'DEFAULT' )tbl1 " + \
                 " LEFT JOIN ( " + \
                 "     SELECT emp_id, emp_name AS supname, email AS supemail " + \
                 "     FROM employee " + \
                 " )tbl2 ON tbl2.emp_id=tbl1.sup_id " + \
                 "ORDER by sup_id, emp_id, timedate "

##        print("########")
##        print(strSQL)
##        print("########")
        
        sql = text(strSQL)
        myFail1ResultList = db.execute(sql).fetchall()

        tblData = ""
        rowData = ""

        lastsupid = 'xyxyxy'
        lastsupname = ''
        #lastsupemail = 'myeducom@yahoo.com'
        #lastsupemail = 'limwaikai2@yahoo.com'
        
        n = 0

        for myFail1Result in myFail1ResultList:
            n = n + 1
            rowData = ""
            
            if chkNull(myFail1Result["sup_id"]) != lastsupid:
                if tblData != "":
                    tblData = "Dear " + lastsupname + ", " + \
                              "<br><br>" + \
                              "The following employees are reminded to perform for ESD smock test. " + \
                              "<br><br>" + \
                              tblData
                    tblData = tblData + "</table>"

                    if lastsupemail != '':
                        emailSent(lastsupemail, tblData)

                    tblData = ""
                    

                tblData = "<table>"
                tblData = tblData + "<tr><td>Supervisor: "
                tblData = tblData + chkNull(myFail1Result["sup_id"]) + "        "
                tblData = tblData + chkNull(myFail1Result["supname"]) + "        "
                tblData = tblData + chkNull(myFail1Result["supemail"]) + "        "
                tblData = tblData + "</td></tr>"
                tblData = tblData + "</table>"

                tblData = tblData + "<table><tr>"
                tblData = tblData + "<td>No</td>"
                tblData = tblData + "<td>TimeDate</td>"
                tblData = tblData + "<td>BadgeNo</td>"
                tblData = tblData + "<td>SmockID</td>"
                tblData = tblData + "<td>Name</td>"
                tblData = tblData + "<td>Department</td>"
                tblData = tblData + "<td>SM</td>"
                tblData = tblData + "<td>Result</td>"
                tblData = tblData + "<td>SM Val</td>"
                tblData = tblData + "<td>SMLo</td>"
                tblData = tblData + "<td>SMHi</td>"
                tblData = tblData + "</td></tr>"

            rowData = rowData + "<tr>"
            rowData = rowData + "<td>" + str(n) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["timedate"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["cardno"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["emp_id"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["emp_name"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["dept_id"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["sm"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["result"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["smval"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["smlo"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["smhi"]) + "</td>"
            rowData = rowData + "</tr>"
                    

            lastsupid = chkNull(myFail1Result["sup_id"])
            lastsupname = chkNull(myFail1Result["supname"])
            lastsupemail = chkNull(myFail1Result["supemail"])

            tblData = tblData + rowData



        if tblData != "":
            tblData = "Dear " + lastsupname + ", " + \
                      "<br><br>" + \
                      "The following employees are reminded to perform for ESD smock test. " + \
                      "<br><br>" + \
                      tblData
            tblData = tblData + "</table>"
            emailSent(lastsupemail, tblData)


    except Exception as e:
         print("chkNoTestONLY: " + str(e))
         print(sql)
    finally:
        print('chkNoTestONLY done')


            

def chkNull(val):
    if val == None:
        return ''
    else:
        return val
    
def chkTaskScheduler():
    global taskname
    global procname
    global dinterval
    global dintervaltype
    global nextrun
    
    try:
        print('chkTaskScheduler start')
        print('')
        chkTaskScheduler = 0
        
        strSQL = "SELECT taskname, procname, dinterval, dintervaltype, nextrun " + \
                 "FROM itasklist " + \
                 "WHERE UPPER(taskname) LIKE '%NOTEST%' " + \
                 "AND UPPER(taskname) LIKE '%ONLY%' " + \
                 "AND UPPER(procname) LIKE '%NOTEST%' " + \
                 "AND UPPER(procname) LIKE '%ONLY%' "

        #print('chkTaskScheduler: ' + strSQL)

        sql = text(strSQL)
        lastclockRow = db.execute(sql).fetchone()

        if lastclockRow is not None:
            taskname = lastclockRow["taskname"]
            procname = chkNull(lastclockRow["procname"])
            dinterval = chkNull(lastclockRow["dinterval"])
            dintervaltype = chkNull(lastclockRow["dintervaltype"])
            nextrun = chkNull(lastclockRow["nextrun"])
            chkTaskScheduler = 1

        print ("taskname : " + str(taskname))
        print ("procname : " + str(procname))
        print ("dinterval : " + str(dinterval))
        print ("dintervaltype : " + str(dintervaltype))
        print ("nextrun : " + str(nextrun))

    except Exception as e :
        print("chkTaskScheduler: " + str(e))
        print(SQL)
    finally:
        print('')
        print('chkTaskScheduler done')
        print('#########################')
        return chkTaskScheduler
            
    time.sleep(5)





if __name__ == '__main__':
    print('Connecting to DB')
    dbConnect()
    if db==None:
        pass
    else:
        taskStatus = chkTaskScheduler()
        if taskStatus == 1:
            chkNoTestONLY()

    print("Closing DB")
    print("")

    print("Done")
        
