from flask_mail import Message
from main import app, mail, setting, session, db

from datetime import datetime

from flask_sqlalchemy import SQLAlchemy
from sqlalchemy.sql import text as SQLQuery


def send_email(subject="ESD Report", \
               sender=app.config['MAIL_DEFAULT_SENDER'], \
               recipients=setting.esdsup, \
               text_body=None, html_body=None, \
               cclist=setting.cclist, bcclist=setting.bcclist):

    myrecipients = list(recipients.split(','))
    mycclist = list(cclist.split(','))
    mybcclist = list(bcclist.split(','))

    msg = Message(subject, sender=sender, recipients=myrecipients, \
                  cc=mycclist, bcc=mybcclist)
    msg.body = text_body
    msg.html = html_body

####    msg.attach('SciSanmina.png', \
####               'image/png', \
####               open('static/images/SciSanmina.png', 'rb').read(), \
####               'inline', \
####               headers=[['Content-ID','<Myimage>'],])
##
##    msg.attach('SciSanmina.png', \
##           'image/png', \
##           open('/home/pi/PythonProj/FlaskWebSmock/static/images/SciSanmina.png', 'rb').read(), \
##           'inline', \
##           headers=[['Content-ID','<Myimage>'],])


    action_result = 'Email Subject: ' + str(subject) + "<br>" + \
                    "Recipients: " + str(recipients)

    strSQL = "INSERT INTO weblog(timedate, action_taken, upd_by, action_sql) " + \
             "VALUES(GETDATE(), 'EMAIL', 'SYSTEM', '" + action_result + "')"
    sql = SQLQuery(strSQL)
    db.session.execute(sql)
    db.session.commit()

    
    mail.send(msg)



def testmail():
    try:
        print("Sending mail...")
        send_email(subject = "Testing", \
                   recipients = "limwaikai@hotmail.com", \
                   html_body="<html><table width=400 border=1><tr><td>first line col1</td><td>firstline col2</td></tr></table></html>")
        print('Mail sent')
    except Exception as e:
        print(str(e))
        #flash(str(e))
