import MySQLdb
import time
import smtplib
#import socket

from time import gmtime, strftime, localtime
from datetime import datetime, timedelta

#disable Mysql Warning
from warnings import filterwarnings
filterwarnings('ignore', category = MySQLdb.Warning)

#Enable Mysql Warning
#from warnings import resetwarnings
#resetWarnings()


global db
#global emailMsg

#emailMsg = ""

from sqlalchemy import create_engine, text

from setting import *
global setting
setting = mysetting()

print setting.dbtype
print setting.dbserver
print setting.dbport
print setting.dbuserid
print setting.dbpassword
print setting.dbschema
print setting.stnno

#gmail_user = 'izzatzul4@gmail.com'  
#gmail_password = 'izzat'

#gmail_receiver = 'izzatzul7@gmail.com'

from email.MIMEText import MIMEText
from email.MIMEBase import MIMEBase
from email import encoders
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText

import email.Utils


# New ######
fromaddr = "smockesd@sanmina.com"
toaddr = ""
HOST = "mailhub.sanmina.com"
############# end

global taskname
global procname
global dinterval
global dintervaltype
global nextrun

taskname = "Test1"
procname = "sudo date"
dinterval = 999
dintervaltype = "MILLISECOND"
nextrun = datetime.strptime("1900-01-01 00:00:00", "%Y-%m-%d %H:%M:%S")

global emailtest
emailtest = False

## uncomment this for real run
#emailtest = True



##msg = MIMEMultipart()
##msg["Message-id"] = email.Utils.make_msgid()
##msg['From'] = fromaddr
##msg['To'] = toaddr
##msg['Subject'] = "Fail Report"

#socket.getaddrinfo('localhost', 25)

def save_EmailWeblog(emailSubject, Recipients):
    global db

    try:
        action_result = 'Email Subject: ' + str(emailSubject) + "<br>" + \
                        "Recipients: " + str(Recipients)
        strSQL = "INSERT INTO weblog(timedate, action_taken, upd_by, action_sql) " + \
                 "VALUES(GETDATE(), 'EMAIL', 'SYSTEM', '" + action_result + "') "

        #print('save_EmailWeblog SQL: ' + str(strSQL))
        sql = text(strSQL)
        db.execute(sql)
    except Exception as e:
        print('save_EmailWeblog: ' + str(e))
    

def emailSent(emailaddress,emailMsg, emailcase):
##    print('##########')
    print(emailaddress)
##    print(emailMsg)
##    print('##########')
##    print('')
    
    global db
    try:
        toaddr = ''
        cc = []
        bcc = ['myeducom@yahoo.com','muqniidataautomation@yahoo.com.my', 'izzatzul4@gmail.com', 'limwaikai2@yahoo.com']
        
        if emailcase == '1':
            emailsubject = "ESD Smock Test Fail "
        else:
            emailsubject = "ESD Smock Test Fail Pending "
            
        msg = MIMEMultipart()
        msg["Message-id"] = email.Utils.make_msgid()
        msg['From'] = fromaddr
        msg['To'] = emailaddress
        msg['CC'] = ",".join(cc)
        msg['Subject'] = emailsubject + datetime.now().strftime("%Y-%m-%d %H:%M:%S")

        

        text = "LastUpdate: " + strftime("%Y-%m-%d %H:%M:%S", localtime())
        
        tHtml = """
        <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
          <title>Turnstiles STATUS</title>
          <style type="text/css" media="screen">
          table {
                width:100%;
            }
            table, th, td {
                border: 1px solid black;
                border-collapse: collapse;
            }
            th, td {
                padding: 5px;
                text-align: left;
            }
            table tr {
                background-color: #E6E6FA;
                color: RED;
                empty-cells:hide;
            }
            table th {
                background-color: #F0E68C;
                color: Black;
                empty-cells:hide;
            }
          </style>
        </head>
        <body>
        """
        tHtml = tHtml + emailMsg + "</body>"
        part1 = MIMEText(tHtml, 'html')
        part2 = MIMEText(text, 'html')
        msg.attach(part1)
        #msg.attach(part2)

        
        server2 = smtplib.SMTP(HOST)
        toaddr = [emailaddress] + cc + bcc
        server2.sendmail(fromaddr, toaddr, msg.as_string())

        if emailaddress != "":
            save_EmailWeblog(str(msg['Subject']), emailaddress)
        
        server2.quit()

        print(emailaddress + ' - Email sent!')
    except Exception as e:  
        print ("Something went wrong..." + str(e))



def dbConnect():
    global db
    try:
        if setting.dbtype.upper() == 'MSSQL':
            dbdriver = 'mssql+pymssql'
        else:
            dbdriver = 'mysql'

        conn_str = dbdriver + '://' + \
                   str(setting.dbuserid) + \
                   ':' + str(setting.dbpassword) + \
                   '@' + str(setting.dbserver) + ':' + str(int(setting.dbport)) + \
                   '/' + str(setting.dbschema)
        timeout = {}
        if setting.dbtype == 'MSSQL':
            timeout['timeout'] = 3
            timeout['login_timeout'] = 5
        else:
            timeout['connect_timeout'] = 3
        
        db = create_engine(conn_str, echo=False, connect_args=timeout)
        
    except:
        db = None
        print("Error: Fail connect to DB")



def chkPendingFail():
    global db

    try:
        if setting.dbtype.upper() == 'MSSQL':
            mysysdate = 'GETDATE() '
        else:
            mysysdate = 'SYSDATE() '
        
        strSQL = "SELECT * FROM ( " + \
                 " SELECT * FROM smockresult " + \
                 " WHERE emp_id IN (SELECT emp_id FROM smockfailtracking) " + \
                 ")tbl1 " + \
                 "LEFT JOIN ( " + \
                 " SELECT emp_id AS empid, MIN(timedate) AS minscan " + \
                 " FROM smockfailtracking " + \
                 " GROUP BY emp_id ) tbl2 " + \
                 " ON tbl2.empid = tbl1.emp_id " + \
                 " WHERE emp_id <> 'NotFound' " + \
                 " AND timedate >= minscan " + \
                 " AND timedate <= " + mysysdate + " " + \
                 " AND UPPER(result) = 'PASS' "

##        print("########")
##        print(strSQL)
##        print("########")
        
        sql = text(strSQL)
        myFail1ResultList = db.execute(sql).fetchall()

        lastempScanID = ""        

        for myFail1Result in myFail1ResultList:
            lastempScanID = lastempScanID + " '" + \
                            chkNull(myFail1Result["emp_id"]) + "', "


        if lastempScanID != "":
            # trim string and remove last comma
            lastempScanID = lastempScanID.strip().rstrip(',')
            
            #copy all fail record to smockfailtracking table
            strSQL = "DELETE FROM smockfailtracking " + \
                     "WHERE emp_id in (" + lastempScanID + ") "

            #print('Delete SQL: ' + str(strSQL))
            sql = text(strSQL)
            db.execute(sql)
        

    except Exception as e:
        print("chkPendingFail : " + str(e))



def getLastScanFail(emailcase):
    global db

    try:
        if setting.dbtype.upper() == 'MSSQL':
            myenddate = "GETDATE() "
            
            if dintervaltype.upper() == "DAY":
                mystartdate = "DATEADD(DAY, -" + str(dinterval) + ", GETDATE())"
            elif dintervaltype.upper() == "HOUR":
                mystartdate = "DATEADD(HOUR, -" + str(dinterval) + ", GETDATE())"
            elif dintervaltype.upper() == "MINUTE":
                mystartdate = "DATEADD(MINUTE, -" + str(dinterval) + ", GETDATE())"
            elif dintervaltype.upper() == "MONTH":
                mystartdate = "DATEADD(MONTH, -" + str(dinterval) + ", GETDATE())"
            else:
                mystartdate = "GETDATE() "
        else:
            if dintervaltype.upper() == "DAY":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " DAY) "
            elif dintervaltype.upper() == "HOUR":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " HOUR) "
            elif dintervaltype.upper() == "MINUTE":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " MINUTE) "
            elif dintervaltype.upper() == "MONTH":
                mystartdate = "DATE_SUB(NOW(), INTERVAL " + str(dinterval) + " MONTH) "
            else:
                mystartdate = "SYSDATE() "

        
        if emailcase == '1':
            strSQL = "SELECT t1.* FROM smockresult t1 " + \
                     "INNER JOIN ( " + \
                     " SELECT emp_id AS empid, MAX(timedate) AS lastscan " + \
                     " FROM smockresult " + \
                     " GROUP BY emp_id ) t2 " + \
                     "ON t1.emp_id = t2.empid AND t1.timedate = t2.lastscan " + \
                     "WHERE emp_id <> 'NotFound' " + \
                     "AND timedate >= " + mystartdate + \
                     "AND timedate <= " + myenddate + " " \
                     "AND UPPER(result) = 'FAIL' " + \
                     "AND emp_id NOT IN (SELECT emp_id FROM smockfailtracking) "
        else:
            strSQL = "SELECT * FROM smockfailtracking " + \
                     "GROUP BY emp_id "
            strSQL = "SELECT *, " + \
                     "RANK() OVER(PARTITION BY emp_id ORDER BY timedate) AS rn " + \
                     "FROM smockfailtracking "
            

        strSQL = "SELECT * FROM ( " + \
                 strSQL + \
                 ")tblsm " + \
                 "LEFT JOIN ( " + \
                 "SELECT emp_id AS supid, emp_name AS supname, email AS supemail " + \
                 "FROM employee )tblsup " + \
                 "ON tblsup.supid = tblsm.sup_id "

        if emailcase != '1':
            strSQL = strSQL + " WHERE rn=1 "

        strSQL = strSQL + "ORDER BY sup_id, timedate, emp_id "

##        print("########")
##        print(strSQL)
##        print("########")
        
        sql = text(strSQL)
        myFail1ResultList = db.execute(sql).fetchall()

        tblData = ""
        rowData = ""

        lastsupid = 'xyxyxy'
        lastsupemail = 'myeducom@yahoo.com'
        #lastsupemail = 'limwaikai2@yahoo.com'

        lastempScanID = ""
        
        n = 0

        for myFail1Result in myFail1ResultList:
            n = n + 1
            rowData = ""

            if emailcase == '1':
                lastempScanID = lastempScanID + " '" + \
                                chkNull(myFail1Result["id"]) + "', "

            
            if chkNull(myFail1Result["sup_id"]) != lastsupid:
                if tblData != "":
                    tblData = tblData + "</table>"
                    print('Email case: ' + emailcase)
                    emailSent(lastsupemail, tblData, emailcase)

                    tblData = ""

                tblData = "<table border=1>"
                tblData = tblData + "<tr><td colspan='11'>Supervisor: "
                tblData = tblData + chkNull(myFail1Result["sup_id"]) + "        "
                tblData = tblData + chkNull(myFail1Result["supname"]) + "        "
                tblData = tblData + chkNull(myFail1Result["supemail"]) + "        "
                tblData = tblData + "</td></tr>"
                #tblData = tblData + "</table>"

                #tblData = tblData + "<table><tr>"
                tblData = tblData + "<tr>"
                tblData = tblData + "<td>No</td>"
                tblData = tblData + "<td>TimeDate</td>"
                tblData = tblData + "<td>BadgeNo</td>"
                tblData = tblData + "<td>SmockID</td>"
                tblData = tblData + "<td>Name</td>"
                tblData = tblData + "<td>Department</td>"
                tblData = tblData + "<td>SM</td>"
                tblData = tblData + "<td>Result</td>"
                tblData = tblData + "<td>SM Val</td>"
                tblData = tblData + "<td>SMLo</td>"
                tblData = tblData + "<td>SMHi</td>"
                tblData = tblData + "</td></tr>"

            rowData = rowData + "<tr>"
            rowData = rowData + "<td>" + str(n) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["timedate"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["cardno"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["emp_id"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["emp_name"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["dept_id"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["SM"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["result"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["SMVal"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["SMLo"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["SMHi"]) + "</td>"
            rowData = rowData + "</tr>"
                    

            lastsupid = chkNull(myFail1Result["sup_id"])

            if emailtest == False:
                lastsupemail = chkNull(myFail1Result["supemail"])

            tblData = tblData + rowData
            


        if tblData != "":
            tblData = tblData + "</table>"
            print('Email case: ' + emailcase)
            emailSent(lastsupemail, tblData, emailcase)


        if lastempScanID != "":
            # trim string and remove last comma
            lastempScanID = lastempScanID.strip().rstrip(',')


            if emailcase == '1':
                #copy all fail record to smockfailtracking table
                strSQL = "INSERT INTO smockfailtracking " + \
                         "SELECT * FROM smockresult " + \
                         "WHERE id in (" + lastempScanID + ") "

                sql = text(strSQL)
                db.execute(sql)
        

    except Exception as e:
        print("getLastScanFail " + emailcase + ": " + str(e))
            

def chkNull(val):
    if val == None:
        return ''
    else:
        return str(val)
    
def chkTaskScheduler():
    global taskname
    global procname
    global dinterval
    global dintervaltype
    global nextrun
    
    try:
        myTaskStatus = 0

        strSQL = "SELECT taskname, procname, dinterval, dintervaltype, nextrun " + \
                 "FROM itasklist " + \
                 "WHERE UPPER(taskname) LIKE '%FAIL%' " + \
                 "AND UPPER(taskname) LIKE '%TRACKING%' " + \
                 "AND UPPER(procname) LIKE '%FAIL%' " + \
                 "AND UPPER(procname) LIKE '%TRACKING%' "

        #print('chkTaskScheduler: ' + SQL + '\n')

        sql = text(strSQL)
        lastclockRow = db.execute(sql).fetchone()

        if lastclockRow is not None:
            taskname = lastclockRow["taskname"]
            procname = chkNull(lastclockRow["procname"])
            dinterval = chkNull(lastclockRow["dinterval"])
            dintervaltype = chkNull(lastclockRow["dintervaltype"])
            nextrun = chkNull(lastclockRow["nextrun"])
            myTaskStatus = 1
        
    except Exception as e :
        print("chkTaskScheduler: " + str(e))
        print(SQL)
    finally:
        print ("taskname : " + str(taskname))
        print ("procname : " + str(procname))
        print ("dinterval : " + str(dinterval))
        print ("dintervaltype : " + str(dintervaltype))
        print ("nextrun : " + str(nextrun))
            
    time.sleep(0.15)

    return myTaskStatus





#while True:
if __name__ == "__main__":
    print('Connecting to DB')
    dbConnect()
    if db==None:
        #break
        print('DB error')
        # sent message

    else:

        # check task setting
        taskStatus = chkTaskScheduler()

        #print('taskStatus: ' + str(taskStatus))

        # if found request task then only do action
        if taskStatus == 1:
            # check empid from smockfailtracking table
            # if any pass then delete from smockfailtracking table
            chkPendingFail()

            # 2nd email condition
            # select all from smockfailtracking in list and email
            # since just now already remove if any pass from last fail
            getLastScanFail('2')

            # 1st email condition
            # check fail record from pass day (exclude empid failed before)
            # if found then email and save to smockfailtracking table
            if getLastScanFail('1') == 0:
                print("Check")
                time.sleep(60)
        else:
            print('NotFound Task')

    

    print("Closing DB")
    print("")

    print("Done")
        
