import MySQLdb
import time
import smtplib
#import socket

from time import gmtime, strftime, localtime
#disable Mysql Warning
from warnings import filterwarnings
filterwarnings('ignore', category = MySQLdb.Warning)

#Enable Mysql Warning
#from warnings import resetwarnings
#resetWarnings()


global db
#global emailMsg

#emailMsg = ""

from sqlalchemy import create_engine, text

from setting import *
global setting
setting = mysetting()

print setting.dbtype
print setting.dbserver
print setting.dbport
print setting.dbuserid
print setting.dbpassword
print setting.dbschema
print setting.stnno

#gmail_user = 'izzatzul4@gmail.com'  
#gmail_password = 'izzat'

#gmail_receiver = 'izzatzul7@gmail.com'

from email.MIMEText import MIMEText
from email.MIMEBase import MIMEBase
from email import encoders
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText

import email.Utils

from datetime import datetime, timedelta

from dateutil.relativedelta import *

# New ######

fromaddr = "iDS900 Smock Tester <smockesd@sanmina.com>"
#toaddr = "mueducom@yahoo.com, izzatzul4@gmail.com, limwaikai2@yahoo.com"
toaddr = ""
HOST = "mailhub.sanmina.com"
############# end

global taskname
global procname
global dinterval
global dintervaltype
global nextrun

taskname = "Test1"
procname = "sudo date"
dinterval = 999
dintervaltype = "MILLISECOND"
nextrun = datetime.strptime("1900-01-01 00:00:00", "%Y-%m-%d %H:%M:%S")


global VERSION
VERSION = 'Ver. 1.00 - 20200120'


def getStartTime(strlastrun, intervaltype, dinterval):
    while strlastrun >= email_endtime:
        if intervaltype == 'DAY':
            strlastrun = strlastrun - relativedelta(days=dinterval)
        elif intervaltype == 'HOUR':
            strlastrun = strlastrun - relativedelta(hours=dinterval)
        elif intervaltype == 'MINUTE':
            strlastrun = strlastrun - relativedelta(minutes=dinterval)
        elif intervaltype == 'MONTH':
            strlastrun = strlastrun - relativedelta(months=dinterval)

    return strlastrun


email_endtime = datetime.now()
email_starttime = getStartTime(email_endtime, 'MONTH', 3)

print(email_starttime.strftime('%Y-%m-%d %H:%M'))

#socket.getaddrinfo('localhost', 25)

def save_EmailWeblog(emailSubject, Recipients):
    global db

    try:
        action_result = 'Email Subject: ' + str(emailSubject) + "<br>" + \
                        "Recipients: " + str(Recipients)
        strSQL = "INSERT INTO weblog(timedate, action_taken, upd_by, action_sql) " + \
                 "VALUES(GETDATE(), 'EMAIL', 'SYSTEM', '" + action_result + "') "

        #print('save_EmailWeblog SQL: ' + str(strSQL))
        sql = text(strSQL)
        db.execute(sql)
    except Exception as e:
        print('save_EmailWeblog: ' + str(e))




def update_LastEmailPasswordAlertExpiry(emailUserID):
    global db

    try:
        if setting.dbtype.upper() == 'MSSQL':
            tblName = "[user] "
        else:
            tblName = "user "
            
        strSQL = "UPDATE " + tblName + " " + \
                 "SET last_email_password_alert_expiry = GETDATE() " + \
                 "WHERE userid = '" + emailUserID + "' "

        #print('update_LastEmailPasswordAlertExpiry SQL: ' + str(strSQL))
        sql = text(strSQL)
        db.execute(sql)
    except Exception as e:
        print('update_LastEmailPasswordAlertExpiry: ' + str(e))
        
        

def emailSent(emailaddress, emailMsg, emailUserID):
    print('')
    print('emailSent start')
##    print('##########')
##    print(emailMsg)
##    print('##########')
##    print('')
    
    global db
    
    global email_starttime
    global email_endtime
    try:

        update_LastEmailPasswordAlertExpiry(emailUserID)

        email_starttime = getStartTime(email_endtime, dintervaltype, dinterval)

        msg = MIMEMultipart()
        msg["Message-id"] = email.Utils.make_msgid()
        msg['From'] = fromaddr
        msg['To'] = emailaddress #toaddr
        msg['Subject'] = "ESD Smock Web Login Password Expiry Soon "


        text = "LastUpdate: " + strftime("%Y-%m-%d %H:%M:%S", localtime())

        
        tHtml = """
        <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
          <title>NoTest Smock Report</title>
          <style type="text/css" media="screen">
          table {
                width:100%;
            }
            table, th, td {
                border: 1px solid black;
                border-collapse: collapse;
            }
            th, td {
                padding: 5px;
                text-align: left;
            }
            table tr {
                background-color: #E6E6FA;
                color: RED;
                empty-cells:hide;
            }
            table th {
                background-color: #F0E68C;
                color: Black;
                empty-cells:hide;
            }
          </style>
        </head>
        <body>
        """
        tHtml = tHtml + emailMsg + "</body>"
        part1 = MIMEText(tHtml, 'html')
        part2 = MIMEText(text, 'html')
        msg.attach(part1)
        #msg.attach(part2)

        
        server2 = smtplib.SMTP(HOST)

        if emailaddress != "":
            print('emailaddress:' + emailaddress + "#")
            #print(msg.as_string())
            server2.sendmail(fromaddr, emailaddress, msg.as_string())

            save_EmailWeblog(str(msg['Subject']), emailaddress)

        server2.quit()

        print(emailaddress + ' - Email sent!')
    except Exception as e:  
        print ("Something went wrong..." + str(e))
    finally:
        print('emailSent done')




def dbConnect():
    global db
    try:
        if setting.dbtype.upper() == 'MSSQL':
            dbdriver = 'mssql+pymssql'
        else:
            dbdriver = 'mysql'

        conn_str = dbdriver + '://' + \
                   str(setting.dbuserid) + \
                   ':' + str(setting.dbpassword) + \
                   '@' + str(setting.dbserver) + ':' + str(int(setting.dbport)) + \
                   '/' + str(setting.dbschema)
        timeout = {}
        if setting.dbtype == 'MSSQL':
            timeout['timeout'] = 3
            timeout['login_timeout'] = 5
        else:
            timeout['connect_timeout'] = 3
        
        db = create_engine(conn_str, echo=False, connect_args=timeout)
        
    except:
        db = None
        print("Error: Fail connect to DB")


def chkUserPasswordExpiry():

    global db

    try:
        print('chkUserPasswordExpiry start')

        if setting.dbtype.upper() == 'MSSQL':

            tblName = "[user] "
            currdate = "CAST(GETDATE() AS DATE) "

            passworemaildexpiry = "DATEADD(DAY, 80, CAST(password_last_change AS DATE)) "
            passwordexpiry = "DATEADD(DAY, 90, CAST(password_last_change AS DATE)) "
            passwordexpired = "DATEADD(DAY, 91, CAST(password_last_change AS DATE)) "


            if dintervaltype.upper() == "DAY":
                passworemaildexpiry = "DATEADD(DAY, " + str(dinterval) + ", CAST(password_last_change AS DATE))"
            elif dintervaltype.upper() == "HOUR":
                passworemaildexpiry = "DATEADD(HOUR, " + str(dinterval) + ", CAST(password_last_change AS DATE))"
            elif dintervaltype.upper() == "MINUTE":
                passworemaildexpiry = "DATEADD(MINUTE, " + str(dinterval) + ", CAST(password_last_change AS DATE))"
            elif dintervaltype.upper() == "MONTH":
                passworemaildexpiry = "DATEADD(MONTH, " + str(dinterval) + ", CAST(password_last_change AS DATE))"
            else:
                passworemaildexpiry = "CAST(GETDATE() AS DATE)"
            
        else:

            tblName = "user "
            currdate = "CURRDATE() "

            passworemaildexpiry = "DATE_ADD(DATE(password_last_change), INTERVAL 80 DAY)"
            passwordexpiry = "DATE_ADD(DATE(password_last_change), INTERVAL 90 DAY)"
            passwordexpired = "DATE_ADD(DATE(password_last_change), INTERVAL 91 DAY)"

            if dintervaltype.upper() == "DAY":
                mystartdate = "DATE_SUB(DATE(password_last_change), INTERVAL " + str(dinterval) + " DAY) "
            elif dintervaltype.upper() == "HOUR":
                mystartdate = "DATE_SUB(DATE(password_last_change), INTERVAL " + str(dinterval) + " HOUR) "
            elif dintervaltype.upper() == "MINUTE":
                mystartdate = "DATE_SUB(DATE(password_last_change), INTERVAL " + str(dinterval) + " MINUTE) "
            elif dintervaltype.upper() == "MONTH":
                mystartdate = "DATE_SUB(DATE(password_last_change), INTERVAL " + str(dinterval) + " MONTH) "
            else:
                mystartdate = "CURRDATE() "

            
            
        strSQL = "SELECT userid, username, accessright, email, " + \
                 "check_password_expired, password_last_change, " + \
                 passworemaildexpiry + " AS password_email_expiry_date, " + \
                 passwordexpiry + " AS password_expiry_date, " + \
                 passwordexpired + " AS password_expired_date, " + \
                 "last_email_password_alert_expiry " + \
                 "FROM " + tblName + " " + \
                 "WHERE 1=1 " + \
                 "AND " + passworemaildexpiry + " = " + currdate + " " + \
                 "AND (last_email_password_alert_expiry IS NULL " + \
                 "      OR CAST(last_email_password_alert_expiry AS DATE) <> CAST(GETDATE() AS DATE)) " + \
                 "ORDER by userid "

##        print("########")
##        print(strSQL)
##        print("########")
        
        sql = text(strSQL)
        myFail1ResultList = db.execute(sql).fetchall()

        tblData = ""
        rowData = ""

        lastuserid = 'xyxyxy'
        lastusername = ''
        #lastuseremail = 'myeducom@yahoo.com'
        #lastuseremail = 'limwaikai2@yahoo.com'
        
        n = 0

        for myFail1Result in myFail1ResultList:
            n = n + 1
            rowData = ""
            
            if chkNull(myFail1Result["userid"]) != lastuserid:
                if tblData != "":
                    tblData = "Dear " + lastusername + ", " + \
                              "<br><br>" + \
                              "Your password ONLY valid until " + \
                              lastuserpasswordexpirydate + \
                              " and will expired at " + \
                              "<b>" + lastuserpasswordexpireddate + "</b>" + \
                              "<br>" + \
                              "Please make sure change password before expired" + \
                              "<br><br>" + \
                              tblData
                    tblData = tblData + "</table>"

                    if lastuseremail != '':
                        emailSent(lastuseremail, tblData, lastuserid)

                    tblData = ""
                    

                tblData = tblData + "<table><tr>"
                tblData = tblData + "<td>UserID</td>"
                tblData = tblData + "<td>Username</td>"
                tblData = tblData + "<td>AccessRight</td>"
                tblData = tblData + "<td>PasswordLastChange</td>"
                tblData = tblData + "</td></tr>"

            rowData = rowData + "<tr>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["userid"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["username"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(myFail1Result["accessright"]) + "</td>"
            rowData = rowData + "<td>" + chkNull(str(myFail1Result["password_last_change"])) + "</td>"
            rowData = rowData + "</tr>"
                    

            lastuserid = chkNull(myFail1Result["userid"])
            lastusername = chkNull(myFail1Result["username"])
            lastuseremail = chkNull(myFail1Result["email"])
            lastusercheckpasswordexpired = chkNull(myFail1Result["check_password_expired"])

            lastuserpasswordexpirydate = chkNull(myFail1Result["password_expiry_date"])
            passwordexpiry = datetime.strptime(lastuserpasswordexpirydate, "%Y-%m-%d")
            lastuserpasswordexpirydate = passwordexpiry.strftime('%d %b %Y')

            lastuserpasswordexpireddate = chkNull(myFail1Result["password_expired_date"])
            passwordexpired = datetime.strptime(lastuserpasswordexpireddate, "%Y-%m-%d")
            lastuserpasswordexpireddate = passwordexpired.strftime('%d %b %Y')

            #print('lastusercheckpasswordexpired: ' + lastusercheckpasswordexpired)
            #print('lastuserpasswordexpireddate: ' + lastuserpasswordexpireddate)

            if lastusercheckpasswordexpired <> '':
                if str(lastusercheckpasswordexpired).upper().find('TRUE') >= 0:
                    tblData = tblData + rowData
                else:
                    tblData = ""
            else:
                tblData = tblData + rowData


        #print(tblData)
        if tblData != "":
            print(lastuserpasswordexpireddate)
            tblData = "Dear " + lastusername + ", " + \
                      "<br><br>" + \
                      "Your password ONLY valid until " + \
                      lastuserpasswordexpirydate + \
                      " and will expired at " + \
                      "<b>" + lastuserpasswordexpireddate + "</b>" + \
                      "<br>" + \
                      "Please make sure change password before expired" + \
                      "<br><br>" + \
                      tblData
            tblData = tblData + "</table>"
            emailSent(lastuseremail, tblData, lastuserid)


    except Exception as e:
         print("chkUserPasswordExpiry: " + str(e))
         print(sql)
    finally:
        print('chkUserPasswordExpiry done')


            

def chkNull(val):
    if val == None:
        return ''
    else:
        return val
    
def chkTaskScheduler():
    global taskname
    global procname
    global dinterval
    global dintervaltype
    global nextrun
    
    try:
        print('chkTaskScheduler start')
        print('')
        chkTaskScheduler = 0
        
        strSQL = "SELECT taskname, procname, dinterval, dintervaltype, nextrun " + \
                 "FROM itasklist " + \
                 "WHERE UPPER(taskname) LIKE '%PASSWORD%' " + \
                 "AND UPPER(taskname) LIKE '%EXPIR%' " + \
                 "AND UPPER(procname) LIKE '%PASSWORD%' " + \
                 "AND UPPER(procname) LIKE '%EXPIR%' "

        #print('chkTaskScheduler: ' + strSQL)

        sql = text(strSQL)
        lastclockRow = db.execute(sql).fetchone()

        if lastclockRow is not None:
            taskname = lastclockRow["taskname"]
            procname = chkNull(lastclockRow["procname"])
            dinterval = chkNull(lastclockRow["dinterval"])
            dintervaltype = chkNull(lastclockRow["dintervaltype"])
            nextrun = chkNull(lastclockRow["nextrun"])
            chkTaskScheduler = 1

        print ("taskname : " + str(taskname))
        print ("procname : " + str(procname))
        print ("dinterval : " + str(dinterval))
        print ("dintervaltype : " + str(dintervaltype))
        print ("nextrun : " + str(nextrun))

    except Exception as e :
        print("chkTaskScheduler: " + str(e))
        print(SQL)
    finally:
        print('')
        print('chkTaskScheduler done')
        print('#########################')
        return chkTaskScheduler
            
    time.sleep(5)





if __name__ == '__main__':
    print('Connecting to DB')
    dbConnect()
    if db==None:
        pass
    else:
        taskStatus = chkTaskScheduler()
        if taskStatus == 1:
            chkUserPasswordExpiry()

    print("Closing DB")
    print("")

    print("Done")
        
