import os, sys

class mysetting():
    def __init__(self):
        self.offline = 0

        self.dTitle = ""
        
        self.webtitle = "iDS700"
        self.model = "iDS700"
        self.version = "1.00"
        
        self.mysqlserver = ""
        self.mysqluserid = ""
        self.mysqlpasswd = ""
        self.mysqlschema = ""

        self.mainserver = ""
        self.mainuserid = ""
        self.mainpasswd = ""
        self.mainschema = ""
        self.mainportno = 3306

        self.dbtype = "MYSQL"
        self.dbserver = "localhost"
        self.dbport = 3306
        self.dbuserid = ""
        self.dbpassword = ""
        self.dbschema = ""
        self.coname = "iDA"
        self.stnno = "STNNO"
        self.deviceno = "000"

        self.testerType = ""
        self.debugmode = False
        self.onlinestatus = 0


        #Email Setting########################
        self.smtpsender = ""
        self.smtpsendername = ""
        self.smtpserver = ""
        self.smtpport = 123
        self.smtpuserid = ""
        self.smtppassword = ""

        self.esdsup = ""
        self.cclist = ""
        self.bcclist = ""

        self.emailintro = ""
        self.emailheader = ""
        self.emailclosing = ""
        ######################################
        
        self.readsetting()



    def chkparm(self, dparm, dparmstr, linestr, dbval=''):
        
        if linestr.find("-" + dparmstr + " ")>=0:
            retval = linestr[len(dparmstr)+1:].strip()
        elif dbval == None:
            return dparm
        elif dbval != '':
            dbval = dbval
            retval = ''
        else:
            return dparm
        
        if retval.find(";")>0:
            retval = retval[:retval.find(";")]
        elif retval.find("#")>=0:
            retval = retval[:retval.find("#")]

        #print 'chkparm here!' + repr(retval)
        if dbval != None :
            #print str(dbval)
            if dbval != '':
                #print 'update retval' + dbval
                retval = dbval

        if (retval == 'False' or retval == 'FALSE'):
            return False
        elif (retval == 'True' or retval == 'TRUE'):
            return True

        try:
            x = float(retval)
            return x
        except:
            return retval
        

    def readsetting(self):
        debugstr = "False"
        
        filepath = os.path.dirname(sys.argv[0])        
        f = open(filepath + '/' + 'setting' + '/coconfig.set','r')

        for line in f:
            linestr = line

            self.dTitle = self.chkparm(self.dTitle, "title", linestr)

            self.webtitle = self.chkparm(self.webtitle, "webtitle", linestr)
            self.model = self.chkparm(self.model, "model", linestr)
            self.version = self.chkparm(self.version, "version", linestr)

            self.dbtype = self.chkparm(self.dbtype, "dbtype", linestr)
            self.dbserver = self.chkparm(self.dbserver, "dbserver", linestr)
            self.dbport = self.chkparm(self.dbport, "dbport", linestr)
            self.dbuserid = self.chkparm(self.dbuserid, "dbuserid", linestr)
            self.dbpassword = self.chkparm(self.dbpassword, "dbpassword", linestr)
            self.dbschema = self.chkparm(self.dbschema, "dbschema", linestr)

            self.coname = self.chkparm(self.coname,"coname", linestr)

            self.testerType = self.chkparm(self.testerType, "testerType", linestr)
                
            self.mysqlserver = self.chkparm(self.mysqlserver, "mysqlserver", linestr)
            self.mysqluserid = self.chkparm(self.mysqluserid, "mysqluserid", linestr)
            self.mysqlpasswd = self.chkparm(self.mysqlpasswd, "mysqlpasswd", linestr)
            self.mysqlschema = self.chkparm(self.mysqlschema, "mysqlschema", linestr)

            self.mainserver = self.chkparm(self.mainserver, "mainserver", linestr)
            self.mainuserid = self.chkparm(self.mainuserid, "mainuserid", linestr)
            self.mainpasswd = self.chkparm(self.mainpasswd, "mainpasswd", linestr)
            self.mainschema = self.chkparm(self.mainschema, "mainschema", linestr)
            self.mainportno = int(self.chkparm(self.mainportno, "mainportno", linestr))

            self.stnno = self.chkparm(self.stnno, "stnno", linestr)
            self.deviceno = int(self.chkparm(self.deviceno, "deviceno", linestr))
            
            self.debugmode = self.chkparm(self.debugmode, "debugmode", linestr)
            debugstr = self.chkparm(debugstr, "debugmode", linestr)


            self.smtpsender = self.chkparm(self.smtpsender, "smtpsender", linestr)
            self.smtpsendername = self.chkparm(self.smtpsendername, "smtpsendername", linestr)
            self.smtpserver = self.chkparm(self.smtpserver, "smtpserver", linestr)
            self.smtpport = int(self.chkparm(self.smtpport, "smtpport", linestr))
            self.smtpuserid = self.chkparm(self.smtpuserid, "smtpuserid", linestr)
            self.smtppassword = self.chkparm(self.smtppassword, "smtppassword", linestr)

            self.esdsup = self.chkparm(self.esdsup, "esdsup", linestr)
            self.cclist = self.chkparm(self.cclist, "cclist", linestr)
            self.bcclist = self.chkparm(self.bcclist, "bcclist", linestr)

            self.emailintro = self.chkparm(self.emailintro, "emailintro", linestr)
            self.emailheader = self.chkparm(self.emailheader, "emailheader", linestr)
            self.emailclosing = self.chkparm(self.emailclosing, "emailclosing", linestr)
            

        if debugstr == True :
            self.debugmode = True


    def chktruefalse(self, parm, valtrue, valfalse):
        if parm:
            print valtrue
        else:
            print valfalse

global setting
setting = mysetting()


if __name__ == '__main__':
    print "setting.py Ver. 0.010"
    print "StnNo: " + setting.stnno
    print "Device No: " + str(setting.deviceno)
